require 'kero/xml_re'
require 'pim/address/person'

module Address
  Filename = ENV["HOME"] + "/.rb-pim/" + "address.xml"

  class Book
    def initialize()
      @person = []
      @attrib = {}  # small hack
      @content = @person  # small hack
    end
    attr_reader :person

    include XmlElt
    def Book::xmlName() "book" end
    def addChild(person)
      @content << person
    end

    def match(re)
      @content.select { |p|
	p.match(re)
      }
    end

    def save_book()
      File.open(Filename, "w") { |f|
	f.write self.to_s
      }
    end
  end

  $address = nil
  if File.exists?(Filename)
    File.open(Filename, "r") { |f|
      parser = XmlParser.new([Book, Person],  Location)
      $address = parser.parseStream(f)[0]
    }
  end
  if $address == nil
    $address = Book.new()
  end
end
